<template>
  <div>
    <template v-if="loading">
      <q-card>
        <q-card-section class="text-center">
          <q-spinner-dots
            size="md"
            color="primary"
          />
        </q-card-section>
      </q-card>
    </template>

    <template v-else-if="activityMessages">
      <q-card
        :square="!isDesktopPlatform"
        v-if="activityMessages.length > 0"
      >
        <q-list separator>
          <q-item-label header>
            <translate>Latest messaging activity</translate>
          </q-item-label>
          <component
            :is="whichListItemComponent(message)"
            v-for="message in activityMessages"
            :key="message.key"
            v-bind="message"
            @click="onClickMessage(message)"
          />
        </q-list>
        <template #loading>
          <div class="row justify-center q-my-md">
            <q-spinner-dots
              color="primary"
              size="40px"
            />
          </div>
        </template>
      </q-card>

      <q-card v-else>
        <q-card-section class="text-body2 text-grey">
          <translate>No messages.</translate>
        </q-card-section>
      </q-card>
    </template>
  </div>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import BroadcastFeedListItem from 'src/pages/home/feed/messaging/BroadcastFeedListItem'
import TicketFeedListItem from 'src/pages/home/feed/messaging/TicketFeedListItem'
import queryLastMessages from './graphql/queryLastMessages.gql'

const DEFAUT_MESSAGE_LIMIT = 6

export default {
  name: 'MessagingFeedCard',
  mixins: [
    PlatformMixin
  ],
  components: {
    BroadcastFeedListItem,
    TicketFeedListItem
  },
  data () {
    return {
      messages: null
    }
  },
  apollo: {
    messages: {
      query: queryLastMessages,
      notifyOnNetworkStatusChange: true,
      variables () {
        return {
          limit: DEFAUT_MESSAGE_LIMIT
        }
      }
    }
  },
  computed: {
    loading () {
      return !this.messages && this.$apollo.queries.messages.loading
    },
    activityMessages () {
      if (!this.messages) {
        return []
      } else {
        return this.messages.map(message => {
          const { id, messageId, messageType, updatedAt, broadcast, ticket } = message
          const listItemMessage = {
            key: id,
            messageId,
            messageType,
            updatedAt
          }
          if (messageType === 'broadcast') {
            return { ...broadcast, ...listItemMessage }
          } else if (messageType === 'ticket') {
            return { ...ticket, ...listItemMessage }
          }
          return null
        })
      }
    }
  },
  methods: {
    onClickMessage (message) {
      this.$router.push({ name: 'message', params: { messageType: message.messageType, messageId: message.messageId } })
    },
    whichListItemComponent (message) {
      switch (message.messageType) {
        case 'broadcast':
          return BroadcastFeedListItem
        case 'ticket':
          return TicketFeedListItem
      }
    }
  }
}
</script>
